#define mutex !(P@cs && Q@cs)
#define entered P@cs
#define enabled (P@attempt && !inCriticalQ)

bool inCriticalP = false;
bool inCriticalQ = false;

active proctype P() {
  attempt:do :: /* non-critical activity */
        atomic {
          !inCriticalQ;
          inCriticalP = true;
        }
        cs:/* critical activity */
        inCriticalP = false
  od
}

active proctype Q() {
  do :: /* non-critical activity */
        atomic {
          !inCriticalP;
          inCriticalQ = true;
        }
        cs:/* critical activity */
        inCriticalQ = false
  od
}
